SdFat: SdFat32 Class Reference

SdFat

Public Member Functions | List of all members
SdFat32 Class Reference

SD file system class for FAT volumes. More...

`#include <SdFat.h>`

Inheritance diagram for SdFat32:
[legend]
Collaboration diagram for SdFat32:
[legend]

## Public Member Functions
bool | begin (BlockDevice *dev, bool setCwv=true, uint8_t part=1)
bool | begin (SdCsPin_t csPin, uint32_t maxSck)
bool | begin (SdCsPin_t csPin=SS)
bool | begin (SdioConfig sdioConfig)
bool | begin (SdSpiConfig spiConfig)
uint16_t | bytesPerCluster () const
uint8_t | bytesPerClusterShift () const
uint16_t | bytesPerSector () const
uint8_t | bytesPerSectorShift () const
uint8_t * | cacheClear ()
SdCard * | card ()
bool | cardBegin (SdioConfig sdioConfig)
bool | cardBegin (SdSpiConfig spiConfig)
bool | chdir ()
bool | chdir (const char *path)
void | chvol ()
uint32_t | clusterCount () const
uint32_t | dataStartSector () const
int8_t | dbgFat (uint32_t n, uint32_t *v)
void | errorHalt (print_t *pr)
void | errorHalt (print_t *pr, const __FlashStringHelper *msg)
void | errorHalt (print_t *pr, const char *msg)
void | errorPrint (Print *pr, const __FlashStringHelper *msg)
void | errorPrint (print_t *pr)
void | errorPrint (print_t *pr, char const *msg)
bool | exists (const char *path)
uint8_t | fatCount () const
uint32_t | fatStartSector () const
uint8_t | fatType () const
bool | format (print_t *pr=NULL)
int32_t | freeClusterCount ()
bool | init (BlockDevice *dev, uint8_t part=1)
void | initErrorHalt (Print *pr, const __FlashStringHelper *msg)
void | initErrorHalt (print_t *pr)
void | initErrorHalt (print_t *pr, const char *msg)
void | initErrorPrint (Print *pr)
bool | isBusy ()
bool | ls (print_t *pr, const char *path, uint8_t flags)
bool | ls (print_t *pr, uint8_t flags=0)
bool | mkdir (const char *path, bool pFlag=true)
File32 | open (const char *path, oflag_t oflag=0X00)
void | printFatType (print_t *pr)
void | printSdError (print_t *pr)
bool | remove (const char *path)
bool | rename (const char *oldPath, const char *newPath)
bool | rmdir (const char *path)
uint16_t | rootDirEntryCount () const
uint32_t | rootDirStart () const
uint8_t | sdErrorCode ()
uint8_t | sdErrorData ()
uint16_t | sectorMask () const
uint8_t | sectorsPerCluster () const
uint8_t | sectorsPerClusterShift () const
uint32_t | sectorsPerFat () const
bool | truncate (const char *path, uint32_t length)
FatVolume * | vol ()
bool | volumeBegin ()
uint32_t | volumeSectorCount () const

## Detailed Description

SD file system class for FAT volumes.

## Member Function Documentation

## ◆ begin() [1/5]

bool FatVolume::begin | ( | BlockDevice * | dev,
|  | bool | setCwv = `true`,
|  | uint8_t | part = `1`
| ) |  |
| inlineinherited

Initialize an FatVolume object.

Parameters

  [in] | dev | Device block driver.
  [in] | setCwv | Set current working volume if true.
  [in] | part | partition to initialize.

Returns
  true for success or false for failure.

## ◆ begin() [2/5]

bool SdBase< FatVolume >::begin | ( | SdCsPin_t | csPin,
|  | uint32_t | maxSck
| ) |  |
| inlineinherited

Initialize SD card and file system.

Parameters

  [in] | csPin | SD card chip select pin.
  [in] | maxSck | Maximum SCK frequency.

Returns
  true for success or false for failure.

## ◆ begin() [3/5]

bool SdBase< FatVolume >::begin | ( | SdCsPin_t | csPin = `SS` | ) |
| inlineinherited

Initialize SD card and file system.

Parameters

  [in] | csPin | SD card chip select pin.

Returns
  true for success or false for failure.

## ◆ begin() [4/5]

bool SdBase< FatVolume >::begin | ( | SdioConfig | sdioConfig | ) |
| inlineinherited

Initialize SD card and file system for SDIO mode.

Parameters

  [in] | sdioConfig | SDIO configuration.

Returns
  true for success or false for failure.

## ◆ begin() [5/5]

bool SdBase< FatVolume >::begin | ( | SdSpiConfig | spiConfig | ) |
| inlineinherited

Initialize SD card and file system for SPI mode.

Parameters

  [in] | spiConfig | SPI configuration.

Returns
  true for success or false for failure.

## ◆ bytesPerCluster()

uint16_t FatPartition::bytesPerCluster | ( |  | ) | const
| inlineinherited

Returns
  Number of bytes in a cluster.

## ◆ bytesPerClusterShift()

uint8_t FatPartition::bytesPerClusterShift | ( |  | ) | const
| inlineinherited

Returns
  The shift count required to multiply by bytesPerCluster.

## ◆ bytesPerSector()

uint16_t FatPartition::bytesPerSector | ( |  | ) | const
| inlineinherited

Returns
  Number of bytes per sector.

## ◆ bytesPerSectorShift()

uint8_t FatPartition::bytesPerSectorShift | ( |  | ) | const
| inlineinherited

Returns
  The shift count required to multiply by bytesPerCluster.

## ◆ cacheClear()

uint8_t* FatPartition::cacheClear | ( |  | ) |
| inlineinherited

Clear the cache and returns a pointer to the cache. Not for normal apps.

Returns
  A pointer to the cache buffer or zero if an error occurs.

## ◆ card()

SdCard* SdBase< FatVolume >::card
| inlineinherited

Returns
  Pointer to SD card object.

## ◆ cardBegin() [1/2]

bool SdBase< FatVolume >::cardBegin | ( | SdioConfig | sdioConfig | ) |
| inlineinherited

Initialize SD card in SDIO mode.

Parameters

  [in] | sdioConfig | SDIO configuration.

Returns
  true for success or false for failure.

## ◆ cardBegin() [2/2]

bool SdBase< FatVolume >::cardBegin | ( | SdSpiConfig | spiConfig | ) |
| inlineinherited

Initialize SD card in SPI mode.

Parameters

  [in] | spiConfig | SPI configuration.

Returns
  true for success or false for failure.

## ◆ chdir() [1/2]

bool FatVolume::chdir | ( |  | ) |
| inlineinherited

Set volume working directory to root.

Returns
  true for success or false for failure.

## ◆ chdir() [2/2]

bool FatVolume::chdir | ( | const char * | path | ) |
| inherited

Set volume working directory.

Parameters

  [in] | path | Path for volume working directory.

Returns
  true for success or false for failure.

## ◆ chvol()

void FatVolume::chvol | ( |  | ) |
| inlineinherited

Change global current working volume to this volume.

## ◆ clusterCount()

uint32_t FatPartition::clusterCount | ( |  | ) | const
| inlineinherited

Returns
  The total number of clusters in the volume.

## ◆ dataStartSector()

uint32_t FatPartition::dataStartSector | ( |  | ) | const
| inlineinherited

Returns
  The logical sector number for the start of file data.

## ◆ dbgFat()

int8_t FatPartition::dbgFat | ( | uint32_t | n,
|  | uint32_t * | v
| ) |  |
| inlineinherited

Debug access to FAT table

Parameters

  [in] | n | cluster number.
  [out] | v | value of entry

Returns
  -1 error, 0 EOC, else 1.

## ◆ errorHalt() [1/3]

void SdBase< FatVolume >::errorHalt | ( | print_t * | pr | ) |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.

## ◆ errorHalt() [2/3]

void SdBase< FatVolume >::errorHalt | ( | print_t * | pr,
|  | const __FlashStringHelper * | msg
| ) |  |
| inlineinherited

Print msg and halt.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ errorHalt() [3/3]

void SdBase< FatVolume >::errorHalt | ( | print_t * | pr,
|  | const char * | msg
| ) |  |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ errorPrint() [1/3]

void SdBase< FatVolume >::errorPrint | ( | Print * | pr,
|  | const __FlashStringHelper * | msg
| ) |  |
| inlineinherited

Print msg, any SD error code.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ errorPrint() [2/3]

void SdBase< FatVolume >::errorPrint | ( | print_t * | pr | ) |
| inlineinherited

Print SD errorCode and errorData.

Parameters

  [in] | pr | Print destination.

## ◆ errorPrint() [3/3]

void SdBase< FatVolume >::errorPrint | ( | print_t * | pr,
|  | char const * | msg
| ) |  |
| inlineinherited

Print msg, any SD error code.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ exists()

bool FatVolume::exists | ( | const char * | path | ) |
| inlineinherited

Test for the existence of a file.

Parameters

  [in] | path | Path of the file to be tested for.

Returns
  true if the file exists else false.

## ◆ fatCount()

uint8_t FatPartition::fatCount | ( |  | ) | const
| inlineinherited

Returns
  The number of File Allocation Tables.

## ◆ fatStartSector()

uint32_t FatPartition::fatStartSector | ( |  | ) | const
| inlineinherited

Returns
  The logical sector number for the start of the first FAT.

## ◆ fatType()

uint8_t FatPartition::fatType | ( |  | ) | const
| inlineinherited

Returns
  The FAT type of the volume. Values are 12, 16 or 32.

## ◆ format()

bool SdFat32::format | ( | print_t * | pr = `NULL` | ) |
| inline

Format a SD card FAT32/FAT16.

Parameters

  [in] | pr | Optional Print information.

Returns
  true for success or false for failure.

## ◆ freeClusterCount()

int32_t FatPartition::freeClusterCount | ( |  | ) |
| inherited

Volume free space in clusters.

Returns
  Count of free clusters for success or -1 if an error occurs.

## ◆ init()

bool FatPartition::init | ( | BlockDevice * | dev,
|  | uint8_t | part = `1`
| ) |  |
| inherited

Initialize a FAT partition.

Parameters

  [in] | dev | BlockDevice for this partition.
  [in] | part | The partition to be used. Legal values for part are 1-4 to use the corresponding partition on a device formatted with a MBR, Master Boot Record, or zero if the device is formatted as a super floppy with the FAT boot sector in sector zero.

Returns
  true for success or false for failure.

## ◆ initErrorHalt() [1/3]

void SdBase< FatVolume >::initErrorHalt | ( | Print * | pr,
|  | const __FlashStringHelper * | msg
| ) |  |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ initErrorHalt() [2/3]

void SdBase< FatVolume >::initErrorHalt | ( | print_t * | pr | ) |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.

## ◆ initErrorHalt() [3/3]

void SdBase< FatVolume >::initErrorHalt | ( | print_t * | pr,
|  | const char * | msg
| ) |  |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ initErrorPrint()

void SdBase< FatVolume >::initErrorPrint | ( | Print * | pr | ) |
| inlineinherited

Print error details after begin() fails.

Parameters

  [in] | pr | Print destination.

## ◆ isBusy()

bool FatPartition::isBusy | ( |  | ) |
| inlineinherited

Check for BlockDevice busy.

Returns
  true if busy else false.

## ◆ ls() [1/2]

bool FatVolume::ls | ( | print_t * | pr,
|  | const char * | path,
|  | uint8_t | flags
| ) |  |
| inlineinherited

List the contents of a directory.

Parameters

  [in] | pr | Print stream for list.
  [in] | path | directory to list.
  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Returns
  true for success or false for failure.

## ◆ ls() [2/2]

bool FatVolume::ls | ( | print_t * | pr,
|  | uint8_t | flags = `0`
| ) |  |
| inlineinherited

List the directory contents of the volume root directory.

Parameters

  [in] | pr | Print stream for list.
  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Returns
  true for success or false for failure.

## ◆ mkdir()

bool FatVolume::mkdir | ( | const char * | path,
|  | bool | pFlag = `true`
| ) |  |
| inlineinherited

Make a subdirectory in the volume root directory.

Parameters

  [in] | path | A path with a valid name for the subdirectory.
  [in] | pFlag | Create missing parent directories if true.

Returns
  true for success or false for failure.

## ◆ open()

File32 FatVolume::open | ( | const char * | path,
|  | oflag_t | oflag = `0X00`
| ) |  |
| inlineinherited

open a file

Parameters

  [in] | path | location of file to be opened.
  [in] | oflag | open flags.

Returns
  a File32 object.

## ◆ printFatType()

void SdBase< FatVolume >::printFatType | ( | print_t * | pr | ) |
| inlineinherited

Print volume FAT/exFAT type.

Parameters

  [in] | pr | Print destination.

## ◆ printSdError()

void SdBase< FatVolume >::printSdError | ( | print_t * | pr | ) |
| inlineinherited

Print error info and return.

Parameters

  [in] | pr | Print destination.

## ◆ remove()

bool FatVolume::remove | ( | const char * | path | ) |
| inlineinherited

Remove a file from the volume root directory.

Parameters

  [in] | path | A path with a valid name for the file.

Returns
  true for success or false for failure.

## ◆ rename()

bool FatVolume::rename | ( | const char * | oldPath,
|  | const char * | newPath
| ) |  |
| inlineinherited

Rename a file or subdirectory.

Parameters

  [in] | oldPath | Path name to the file or subdirectory to be renamed.
  [in] | newPath | New path name of the file or subdirectory.

The newPath object must not exist before the rename call.

The file to be renamed must not be open. The directory entry may be moved and file system corruption could occur if the file is accessed by a file object that was opened before the rename() call.

Returns
  true for success or false for failure.

## ◆ rmdir()

bool FatVolume::rmdir | ( | const char * | path | ) |
| inlineinherited

Remove a subdirectory from the volume's working directory.

Parameters

  [in] | path | A path with a valid name for the subdirectory.

The subdirectory file will be removed only if it is empty.

Returns
  true for success or false for failure.

## ◆ rootDirEntryCount()

uint16_t FatPartition::rootDirEntryCount | ( |  | ) | const
| inlineinherited

Returns
  The number of entries in the root directory for FAT16 volumes.

## ◆ rootDirStart()

uint32_t FatPartition::rootDirStart | ( |  | ) | const
| inlineinherited

Returns
  The logical sector number for the start of the root directory on FAT16 volumes or the first cluster number on FAT32 volumes.

## ◆ sdErrorCode()

uint8_t SdBase< FatVolume >::sdErrorCode
| inlineinherited

Returns
  SD card error code.

## ◆ sdErrorData()

uint8_t SdBase< FatVolume >::sdErrorData
| inlineinherited

Returns
  SD card error data.

## ◆ sectorMask()

uint16_t FatPartition::sectorMask | ( |  | ) | const
| inlineinherited

Returns
  Mask for sector offset.

## ◆ sectorsPerCluster()

uint8_t FatPartition::sectorsPerCluster | ( |  | ) | const
| inlineinherited

Returns
  The volume's cluster size in sectors.

## ◆ sectorsPerClusterShift()

uint8_t FatPartition::sectorsPerClusterShift | ( |  | ) | const
| inlineinherited

Returns
  The shift count required to multiply by sectorsPerCluster.

## ◆ sectorsPerFat()

uint32_t FatPartition::sectorsPerFat | ( |  | ) | const
| inlineinherited

Returns
  The number of sectors in one FAT.

## ◆ truncate()

bool FatVolume::truncate | ( | const char * | path,
|  | uint32_t | length
| ) |  |
| inlineinherited

Truncate a file to a specified length. The current file position will be at the new EOF.

Parameters

  [in] | path | A path with a valid name for the file.
  [in] | length | The desired length for the file.

Returns
  true for success or false for failure.

## ◆ vol()

FatVolume * SdBase< FatVolume >::vol
| inlineinherited

Returns
  pointer to base volume

## ◆ volumeBegin()

bool SdBase< FatVolume >::volumeBegin
| inlineinherited

Initialize file system after call to cardBegin.

Returns
  true for success or false for failure.

## ◆ volumeSectorCount()

uint32_t FatPartition::volumeSectorCount | ( |  | ) | const
| inlineinherited

Returns
  The number of sectors in the volume

The documentation for this class was generated from the following file:

- ArduinoSdFat/libraries/SdFat/src/SdFat.h